org.apache.tinkerpop.gremlin.process.computer

## Class GraphComputerTest.VertexProgramJ

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.computer.util.StaticVertexProgram
  - - org.apache.tinkerpop.gremlin.process.computer.GraphComputerTest.VertexProgramJ

- All Implemented Interfaces:
    Cloneable, VertexProgram
  Enclosing class:
    GraphComputerTest

      public static class GraphComputerTest.VertexProgramJ
      extends StaticVertexProgram

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VertexProgram.Builder, VertexProgram.Features`

  - ### Field Summary

    - ### Fields inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VERTEX_PROGRAM`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `VertexProgramJ()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `execute(Vertex vertex, Messenger messenger, Memory memory)` This method denotes the main body of the computation and is executed on each vertex in the graph.
    `Set<MemoryComputeKey>` | `getMemoryComputeKeys()` The `Memory` keys that will be used during the computation.
    `Set<MessageScope>` | `getMessageScopes(Memory memory)` This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program.
    `GraphComputer.Persist` | `getPreferredPersist()`
    `GraphComputer.ResultGraph` | `getPreferredResultGraph()`
    `void` | `setup(Memory memory)` The method is called at the beginning of the computation.
    `boolean` | `terminate(Memory memory)` The method is called at the end of each iteration to determine if the computation is complete.
    `void` | `workerIterationEnd(Memory memory)` This method is called at the end of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism.
    `void` | `workerIterationStart(Memory memory)` This method is called at the start of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism.

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.computer.util.StaticVertexProgram

      `clone, storeState`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `createVertexProgram, getFeatures, getMapReducers, getMessageCombiner, getTraverserRequirements, getVertexComputeKeys, loadState`

- - ### Constructor Detail

    - #### VertexProgramJ

          public VertexProgramJ()

  - ### Method Detail

    - #### setup

          public void setup(Memory memory)

      Description copied from interface: `VertexProgram`
      The method is called at the beginning of the computation. The method is global to the `GraphComputer` and as such, is not called for each vertex. During this stage, the `Memory` should be initialized to to its "start state."
      Parameters:
        `memory` - The global memory of the GraphComputer

    - #### workerIterationStart

          public void workerIterationStart(Memory memory)

      Description copied from interface: `VertexProgram`
      This method is called at the start of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism. The vertex set is split into subsets and a worker is assigned to call the `VertexProgram.execute(org.apache.tinkerpop.gremlin.structure.Vertex, org.apache.tinkerpop.gremlin.process.computer.Messenger<M>, org.apache.tinkerpop.gremlin.process.computer.Memory)` method. The default implementation is a no-op.
      Parameters:
        `memory` - The memory at the start of the iteration.

    - #### execute

          public void execute(Vertex vertex,
                              Messenger messenger,
                              Memory memory)

      Description copied from interface: `VertexProgram`
      This method denotes the main body of the computation and is executed on each vertex in the graph. This method is logically executed in parallel on all vertices in the graph. When the `Memory` is read, it is according to the aggregated state yielded in the previous iteration. When the `Memory` is written, the data will be aggregated at the end of the iteration for reading in the next iteration.
      Parameters:
        `vertex` - the `Vertex` to execute the `VertexProgram` on
        `messenger` - the messenger that moves data between vertices
        `memory` - the shared state between all vertices in the computation

    - #### terminate

          public boolean terminate(Memory memory)

      Description copied from interface: `VertexProgram`
      The method is called at the end of each iteration to determine if the computation is complete. The method is global to the `GraphComputer` and as such, is not called for each `Vertex`. The `Memory` maintains the aggregated data from the last execute() iteration.
      Parameters:
        `memory` - The global memory of the `GraphComputer`
      Returns:
        whether or not to halt the computation

    - #### workerIterationEnd

          public void workerIterationEnd(Memory memory)

      Description copied from interface: `VertexProgram`
      This method is called at the end of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism. The vertex set is split into subsets and a worker is assigned to call the `VertexProgram.execute(org.apache.tinkerpop.gremlin.structure.Vertex, org.apache.tinkerpop.gremlin.process.computer.Messenger<M>, org.apache.tinkerpop.gremlin.process.computer.Memory)` method. The default implementation is a no-op.
      Parameters:
        `memory` - The memory at the end of the iteration.

    - #### getMemoryComputeKeys

          public Set<MemoryComputeKey> getMemoryComputeKeys()

      Description copied from interface: `VertexProgram`
      The `Memory` keys that will be used during the computation. These are the only keys that can be read or written throughout the life of the `GraphComputer`. The default is an empty set.
      Returns:
        the set of memory keys that will be read/written

    - #### getMessageScopes

          public Set<MessageScope> getMessageScopes(Memory memory)

      Description copied from interface: `VertexProgram`
      This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program. The returned messages scopes are the scopes that will be used to send messages during the stated iteration. It is not a requirement that all stated messages scopes be used, just that it is possible that they be used during the iteration.
      Parameters:
        `memory` - an immutable form of the `Memory`
      Returns:
        all possible message scopes during said vertex program iteration

    - #### getPreferredResultGraph

          public GraphComputer.ResultGraph getPreferredResultGraph()

    - #### getPreferredPersist

          public GraphComputer.Persist getPreferredPersist()

Copyright © 2013–2018 Apache Software Foundation. All rights reserved.